/*
 * Copyright (c) 2004 Sendmail, Inc. and its suppliers.
 *      All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 *	$Id: pmilter.h,v 1.2 2004/10/12 18:24:58 ca Exp $
 */

#ifndef SM_PMILTER_H
#define SM_PMILTER_H	1

#include "sm/generic.h"
#include "sm/types.h"
#include "sm/memops.h"

/*
**  protocol version
*/

#define SM_PMILTER_PROT	0x00000100	/* major.minor */

/*
**  SMTP server capabilities
*/

#define SM_SC_NONE	0x00000000
#define SM_SC_CONNECT	0x00000001
#define SM_SC_EHLO	0x00000002
#define SM_SC_MAIL	0x00000010
#define SM_SC_RCPT	0x00000020
#define SM_SC_DATA	0x00000040
#define SM_SC_BODY	0x00000080

#define SM_SC_ALL	0x000000F7

/*
**  SMTP server requirements
**  ???
*/

#define SM_SR_NONE	0x00000000

/*
**  PMILTER capabilities
**  ???
*/

#define SM_PC_NONE	0x00000000

/*
**  PMILTER requirements
**  ???
*/

#define SM_PR_NONE	SM_SC_NONE
#define SM_PR_CONNECT	SM_SC_CONNECT
#define SM_PR_EHLO	SM_SC_EHLO
#define SM_PR_MAIL	SM_SC_MAIL
#define SM_PR_RCPT	SM_SC_RCPT
#define SM_PR_DATA	SM_SC_DATA
#define SM_PR_BODY	SM_SC_BODY

int smfi_main(void);

#endif /* SM_PMILTER_H */
