/*
 * Copyright (c) 2004 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: sm-conf-prtdef.c,v 1.4 2004/10/31 03:54:46 ca Exp $")

#include "sm/string.h"
#include "sm/sm-conf.h"
#include "sm/sm-conf-prt.h"
#include "sm-conf-type.h"
#include "sm/io.h"
#include "sm/util.h"

/* show configuration definition */

#if 0
struct sm_conf_definition_S
{
	sm_magic_T			 sm_magic;

	char const			*scd_name;
	const sm_conf_type_T		*scd_type;
	unsigned long			 scd_offset;
	size_t				 scd_size;
	char const			*scd_default;
	unsigned int			 scd_flags;
	sm_conf_definition_T const	*scd_contents;
	sm_conf_definition_check_T	*scd_check;
	void				*scd_check_data;
};
	int (* sctp_node_to_value)(
		sm_conf_T			*_handle,
		sm_conf_definition_T const	*_def,
		sm_conf_node_T const		*_node,
		void				*_value);
	int (* sctp_value_check)(
		sm_conf_T			*_handle,
		sm_conf_definition_T const	*_def,
		void const			*_value);
	int (* sctp_value_copy)(
		sm_conf_T			*_handle,
		sm_conf_definition_T const	*_def,
		void				*_to,
		void const			*_from);
	int (* sctp_value_null)(
		sm_conf_T			*_handle,
		sm_conf_definition_T const	*_def,
		void				*_value);
#endif /* 0 */

static int
sm_conf_prt_def(const sm_conf_definition_T *def, sm_file_T *fp, int indent)
{
	const sm_conf_type_T *scdtype;

	SM_IS_CONF_DEF(def);
	scdtype = def->scd_type;
	if (scdtype != NULL)
	{
		if (def->scd_description != NULL &&
		    *(def->scd_description) != '\0')
		{
			prt_fmtted(fp, indent, "# ", def->scd_description);
		}
		if (scdtype == sm_conf_type_section)
		{
			sm_io_fprintf(fp, "\n%*s%s {\n"
				, indent, ""
				, def->scd_name);
			sm_conf_prt_defs(def->scd_contents, fp, indent + 2);
			sm_io_fprintf(fp, "%*s}\n"
				, indent, "");
		}
		else if (scdtype == sm_conf_type_string)
			sm_io_fprintf(fp, "%*s%s=\"%s\";\n"
				, indent, ""
				, def->scd_name
				, def->scd_default);
		else
			sm_io_fprintf(fp, "%*s%s=%s;\n"
				, indent, ""
				, def->scd_name
				, def->scd_default);
	}
	return 0;
}

int
sm_conf_prt_defs(const sm_conf_definition_T *defs, sm_file_T *fp, int indent)
{
	const sm_conf_definition_T *def;

	while ((def = defs++) != NULL && def->scd_name != NULL)
	{
		SM_IS_CONF_DEF(def);
		sm_conf_prt_def(def, fp, indent);
#if 0
		sm_io_fprintf(fp, "name=\"%s\"\n", def->scd_name);
		scdtype = def->scd_type;
		if (scdtype != NULL && scdtype->sctp_node_to_value != NULL)
		{
			r = (*scdtype->sctp_node_to_value)(
					stream,
					def,
					NULL,
					(void *)def->scd_default);
			r = (*scdtype->sctp_value_null)(
					stream,
					def,
					((char *)&sm_cnf) + def->scd_offset);
			sm_io_fprintf(fp, "r=%d, def=%s\n", r, def->scd_default);
			if (sm_conf_type_section,
			sm_io_fprintf(fp, "def=%s\n", def->scd_default);

		}
#endif /* 0 */

	}
	return 0;
}
