#!/bin/sh
# $Id: t-dumpdef-0.sh,v 1.45 2005/04/28 06:15:26 ca Exp $
# Copyright (c) 2004 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# show ("dump") configuration
# uses dumpdef
# ----------------------------------------

test -s stop && exit 1

# source directory of this (and other) shell script
SD=`dirname $0`

ERRS=0

CNF=smx.conf
OUT=smx.out
OK=smx.ok

PRG=./dumpdef

cat > ${CNF} <<EOF
EOF

${PRG} -VVV |grep 'SM_USE_SASL' >${OUT} 2>&1
if test -s ${OUT}
then
AUTHOPTS='auth {
# Flags for Cyrus SASL (AUTH)
flags=(null);
# List of SASL mechanisms for which relaying is allowed if a client
# successfully authenticated using one of those
trusted_mechanisms="PLAIN LOGIN DIGEST-MD5 CRAM-MD5";
}'
else
AUTHOPTS=""
fi

${PRG} -VVV |grep 'SM_USE_TLS' >${OUT} 2>&1
if test -s ${OUT}
then
TLSSRVOPTS='tls {
# File with certificate in PEM format
cert_file="smcert.pem";
# File with private key for certificate in PEM format
key_file="smkey.pem";
# File with CA certificate in PEM format
CAcert_file="CAcert.pem";
# Directory with (symbolic links for) CA certificates in PEM format
CAcert_path="certs";
# flags to influence behavior related to STARTTLS [see documentation]
flags=(null);
}'
else
TLSSRVOPTS=""
fi

${PRG} -VVV |grep 'SM_USE_TLS' >${OUT} 2>&1
if test -s ${OUT}
then
TLSOPTS='tls {
# File with certificate in PEM format
cert_file="smcert.pem";
# File with private key for certificate in PEM format
key_file="smkey.pem";
# File with CA certificate in PEM format
CAcert_file="CAcert.pem";
# Directory with (symbolic links for) CA certificates in PEM format
CAcert_path="certs";
}'
else
TLSOPTS=""
fi

${PRG} -VVV |grep 'SM_USE_PMILTER' >${OUT} 2>&1
if test -s ${OUT}
then
PMILTEROPTS='pmilter {
# path of Unix domain socket to communicate with policy milter
socket="(null)";
# maximum amount of time to wait for a reply from a policy milter
timeout=20;
# policy milter flags [see documentation]
flags=(null);
}'
else
PMILTEROPTS=""
fi

${PRG} -VVV |grep 'QMGR_TEST' >${OUT} 2>&1
if test -s ${OUT}
then
QMGRTESTOPTS='
tests=0;'
else
QMGRTESTOPTS=""
fi

sed -e 's/^  *//' -e '/^$/d' > ${OK} <<EOF
SMTPC_socket="qmsmtpc/qmsmtpc";
SMTPS_socket="qmsmtps/qmsmtps";
SMAR_socket="qmsmar/qmsmar";
CDB_base_directory="";
smar {
# List of nameservers (IPv4 addresses)
nameserver=(null);
DNS_Flags=(null);
DNS_timeout=2;
log_level=99999;
# Specify syslog configuration instead of logging to files
log {
# options for openlog(3)
options=(null);
# facility for openlog(3)
facility=(null);
# ident for openlog(3)
ident="(null)";
}
# minimum number of threads [experts only]
min_threads=2;
# maximum number of threads [experts only]
max_threads=16;
# maximum number of file descriptors [experts only]
max_fds=10;
# Map specifying valid local users/addresses
local_user_map="(null)";
# DNS based blacklists
dnsbl=(null);
# Map Declarations
map=(null);
# delimiter for address extensions in local part
address_delimiter=+;
# name of aliases map (including extension)
aliases="aliases.db";
# mailertable
mailertable="mt";
# name of access map (including extension)
access="access.db";
# minimum number of processes
min_processes=1;
# maximum number of processes
max_processes=1;
# run process as user
user="";
# run process as group
group="";
# list of services to restart in case of failure
restartdependencies=(null);
# pass id to process in argument list with this option
pass_id="(null)";
# use id to create name of logfile: Logdir name id . log
use_id_in_logfile_name=0;
# path to program
path="";
# arguments for program
arguments="";
# how to handle program
mcp_type="wait";
}
smtpc {
# port to connect to on server
remote_port=SMTPC_PORT;
LMTP_socket="lmtpsock";
# number of processes to start [currently not implemented]
processes=1;
# maximum number of waiting threads
max_wait_threads=MAX_WAIT_THREADS_DEFAULT;
# minimum number of waiting threads
min_wait_threads=MIN_WAIT_THREADS_DEFAULT;
flags=0;
log_level=99999;
log {
# options for openlog(3)
options=(null);
# facility for openlog(3)
facility=(null);
# ident for openlog(3)
ident="(null)";
}
debug_level=0;
# timeout for SMTP I/O operations
io_timeout=SC_IO_TIMEOUT;
# maximum amount of time to wait for a server to become available
wait_for_server=1;
# unique id
id=SMTPC_ID;
# connect only to this IPv4 address [testing]
connect_only_to=0;
${TLSOPTS}
# minimum number of processes
min_processes=1;
# maximum number of processes
max_processes=1;
# run process as user
user="";
# run process as group
group="";
# list of services to restart in case of failure
restartdependencies=(null);
# pass id to process in argument list with this option
pass_id="(null)";
# use id to create name of logfile: Logdir name id . log
use_id_in_logfile_name=0;
# path to program
path="";
# arguments for program
arguments="";
# how to handle program
mcp_type="wait";
}
smtps {
# path of Unix domain socket to exchange file descriptor [use with MCP]
pass_fd_socket="(null)";
# address for daemon to listen on [do not use with MCP]
daemon_address=(null);
# log level
log_level=99999;
# specify syslog(3) configuration instead of logging to files
log {
# options for openlog(3)
options=(null);
# facility for openlog(3)
facility=(null);
# ident for openlog(3)
ident="(null)";
}
# allow relaying from IPv4 addresses that match this regular expression
relay_from="127.0.0.1";
# allow relaying to addresses that match this regular expression
relay_to="(^<postmaster>|@localhost>)$";
# group id (numeric) to use for CDB files
cdb_gid=0;
# (unique) id for server (if multiple SMTP servers are configured)
id=0;
# maximum number of transactions per session
max_transactions=65535;
# maximum number of recipients per session
max_recipients=65535;
# maximum number of hops (Received: headers)
max_hops=21;
# maximum message size (KB)
max_message_size=8 *1024;
# maximum line length (0: no limit)
max_line_length=0;
# timeout for SMTP I/O operations
io_timeout=90;
# flags to influence behavior [see documentation]
flags=(null);
# maximum number of threads
max_threads=0;
# maximum number of waiting threads
max_wait_threads=8;
# minimum number of waiting threads
min_wait_threads=2;
# number of processes to start
processes=1;
# length of listen(2) queue
listen_queue=256;
# maximum amount of time to wait for a server to become available
wait_for_server=1;
# maximum amount of time to wait for a reply from smar
wait_for_smar=20;
# debug level
debug_level=0;
${TLSSRVOPTS}
${AUTHOPTS}
${PMILTEROPTS}
# port to listen on
port=0;
# bind to this IPv4 address
address=0.0.0.0;
# minimum number of processes
min_processes=1;
# maximum number of processes
max_processes=1;
# run process as user
user="";
# run process as group
group="";
# list of services to restart in case of failure
restartdependencies=(null);
# pass id to process in argument list with this option
pass_id="(null)";
# use id to create name of logfile: Logdir name id . log
use_id_in_logfile_name=0;
# path to program
path="";
# arguments for program
arguments="";
# how to handle program
mcp_type="wait";
}
qmgr {
# Maximum number of entries in AQ (active queue)
AQ_max_entries=4096;
# Maximum number of entries in OCC (outgoing connection cache)
OCC_max_entries=2111;
ibdb {
# maximum size of each IBDB file
size=65536;
# maximum number of open transactions in IBDB before a commit is performed
max_open_TAs=SM_Q_OPEN_TAS;
# maximum time between commits to IBDB (micro seconds)
max_commit_delay=IBDB_DELAY;
}
iqdb {
# maximum number of entries in IQDB cache
max_cache_entries=1023;
# size of hash table for IQDB
hash_table_entries=2111;
}
# minimum amount of free disk space (KB)
min_disk_space=16 *1024;
# amount of free disk space at which normal operation continues (KB)
ok_disk_space=32 *1024;
# initial number of outgoing connections to a single host
smtpc_initial_connections=DA_INIT_CONC_CONN;
# maximum number of outgoing connections to a single host
smtpc_max_connections=DA_MAX_CONC_CONN;
# maximum number of open incoming connection from a single host
smtps_max_open_connections=SS_MAX_OPEN_SE;
# maximum incoming connection rate from a single host
smtps_max_connection_rate=SS_MAX_CONN_RATE;
# maximum number of error messages (failed recipients) in a bounce (DSN)
max_errors_per_bounce=AQR_DSN_RCPTS_MAX;
flags=(null);
# minimum time for retrying a delivery
retry_min_delay=MIN_DELAY_NXT_TRY;
# maximum time for retrying a delivery
retry_max_delay=MAX_DELAY_NXT_TRY;
# maximum time in queue
queuereturn_timeout=7200u;
# timeout in address resolver
SMAR_timeout=120u;
# timeout for a single delivery attempt
delivery_timeout=600u;
# maximum time waiting to be scheduled
scheduler_timeout=600u;
# maximum time for scheduling a DSN
DSN_max_delay=1u;
# maximum amount of time to wait for a server to become available
wait_for_server=1;
# maximum amount of time to wait for a client to become available
wait_for_client=1;
log_level=99999;
# Specify syslog configuration instead of logging to files
log {
# options for openlog(3)
options=(null);
# facility for openlog(3)
facility=(null);
# ident for openlog(3)
ident="(null)";
}
debug_level=0;${QMGRTESTOPTS}
defedb {
# Home directory for DEFEDB
base_directory="(null)";
# Log directory for DEFEDB
log_directory="(null)";
# DB page size
page_size=(null);
# DB cache size
cache_size=(4 * 1024 * 1024);
# If non-zero, a checkpoint will be done if more than the amount of KBytes
# of log data have been written since the last checkpoint
KBytes_written_for_checkpointing=(null);
# Minimum delay between two checkpoints
delay_between_2_checkpoints=600;
}
control_socket="(null)";
# Name of conf map (including extension)
conf="(null)";
# minimum number of threads [experts only]
min_threads=2;
# maximum number of threads [experts only]
max_threads=6;
# maximum number of file descriptors [experts only]
max_fds=10;
# minimum number of processes
min_processes=1;
# maximum number of processes
max_processes=1;
# run process as user
user="";
# run process as group
group="";
# list of services to restart in case of failure
restartdependencies=(null);
# pass id to process in argument list with this option
pass_id="(null)";
# use id to create name of logfile: Logdir name id . log
use_id_in_logfile_name=0;
# path to program
path="";
# arguments for program
arguments="";
# how to handle program
mcp_type="wait";
}
EOF

if ${PRG} ${CNF} | sed -e 's/^  *//' -e '/^$/d' >${OUT}
then
  if diff ${OK} ${OUT}
  then
    :
  else
    ERRS=`expr ${ERRS} + 1 `
  fi
else
  ERRS=`expr ${ERRS} + 1 `
fi

# ----------------
if test "${ERRS}" = "0"
then
  exit 0
else
  echo "${ERRS} error(s)"
  exit 1
fi
