/*
 * Copyright (c) 2004 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: pmilter.c,v 1.5 2005/03/15 19:56:08 ca Exp $")
#include "sm/error.h"
#include "sm/assert.h"
#include "sm/sysexits.h"
#include "sm/signal.h"
#include "sm/io.h"
#include "sm/pmilter.h"
#define PMILTER_DEBUG_DEFINE 1
#include "pmilter.h"

#if SM_USE_PMILTER

/*
**  SMFI_MAIN -- setup milter connnection and start listener.
**
**	Parameters:
**		none.
**
**	Returns:
**		MI_SUCCESS/MI_FAILURE
*/

int
smfi_main(void)
{
	sm_ret_T ret;
	pmilt_ctx_P pmilt_ctx;

	(void) signal(SIGPIPE, SIG_IGN);
#if 0
	(void) atexit(mi_clean_signals);
#endif /* 0 */

	ret = sm_pmilt_init0(&pmilt_ctx);
	if (sm_is_err(ret))
	{
		sm_io_fprintf(smioerr, "sev=ERROR, pmilt_init0=%r\n", ret);
		goto error;
	}

	ret = sm_pmilt_init1(pmilt_ctx);
	if (sm_is_err(ret))
	{
		sm_io_fprintf(smioerr, "sev=ERROR, pmilt_init1=%r\n", ret);
		goto error;
	}

	/* startup */
	ret = sm_pmilt_start(pmilt_ctx);
	if (sm_is_err(ret))
	{
		sm_io_fprintf(smioerr, "sev=ERROR, sm_pmilt_start=%x\n", ret);
		goto error;
	}

	/* wait for events, schedule tasks */
	ret = evthr_loop(pmilt_ctx->pmilt_ev_ctx);

  error:
	/* ignore shutdown errors... */
	(void) sm_pmilt_stop(pmilt_ctx);
	return ret;
}

#endif /* SM_USE_PMILTER */
